use local_ip_address::local_ip;
use tide::prelude::*;
use tide::Request;

#[derive(Debug, Deserialize)]
struct Sample {
    message: String,
    value: i32,
}

#[async_std::main]
async fn main() -> tide::Result<()> {
    let mut app = tide::new();
    app.at("/sample").post(send_sample);
    if let Ok(ip) = local_ip() {
        println!("Starting server at {ip}:8000!");
    } else {
        println!("Starting server on port 8000. Could not get IP");
    }
    app.listen("0.0.0.0:8000").await?;
    Ok(())
}

async fn send_sample(mut req: Request<()>) -> tide::Result {
    let Sample { message, value } = req.body_json().await?;
    println!("Ok, message: {}, value: {}", message, value);
    Ok(format!("Ok, message: {}, value: {}", message, value).into())
}
